=== debian/changelog ===
telepathy-logger-qt5 (0.5.1-0ubuntu4) trusty; urgency=medium

  * Rebuild to solve a powerpc dependency problem.

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Fri, 07 Mar 2014 11:40:19 +0200

telepathy-logger-qt5 (0.5.1-0ubuntu3) trusty; urgency=medium

  * Rebuild against Qt 5.2.1

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Wed, 05 Mar 2014 09:45:47 +0200

telepathy-logger-qt5 (0.5.1-0ubuntu2) saucy; urgency=low

  * Renaming source package until upstream supports building both Qt4 and Qt5
    versions from the same source (and with Qt5 final)
  * Applying changes to port to Qt5 done for Ubuntu Touch:
    - 01-Porting-to-Qt5-final.patch

 -- Ricardo Salveti de Araujo <ricardo.salveti@canonical.com>  Thu, 06 Jun 2013 23:07:05 -0300

telepathy-logger-qt (0.5.1-0ubuntu1) quantal-proposed; urgency=low

  * New upstream release

 -- Rohan Garg <rohangarg@kubuntu.org>  Fri, 05 Oct 2012 03:40:32 +0530

telepathy-logger-qt (0.5.0-0ubuntu1) quantal; urgency=low

  * New upstream release

 -- Rohan Garg <rohangarg@kubuntu.org>  Sun, 26 Aug 2012 12:47:08 +0530

telepathy-logger-qt (0.4.1-0ubuntu1) quantal; urgency=low

  * New upstream release

 -- Michal Zajac <quintasan@kubuntu.org>  Wed, 01 Aug 2012 00:07:22 +0200

telepathy-logger-qt (0.4.0-1) unstable; urgency=low

  * Initial release.

 -- George Kiagiadakis <kiagiadakis.george@gmail.com>  Mon, 18 Jun 2012 22:28:46 +0300
